# thermal/consumers.py

import os
import subprocess
from channels.generic.websocket import AsyncWebsocketConsumer
import json
import asyncio

class CommandConsumer(AsyncWebsocketConsumer):
    async def connect(self):
        await self.accept()

    async def disconnect(self, close_code):
        pass

    async def receive(self, text_data):
        data = json.loads(text_data)
        threads = data['threads']
        runs = data['runs']

        # プロジェクトのルートディレクトリにある measure を実行する
        command = f"./bin/measure {threads} {runs}"
        process = await asyncio.create_subprocess_shell(
            command,
            stdout=asyncio.subprocess.PIPE,
            stderr=asyncio.subprocess.PIPE
        )

        while True:
            if process.stdout.at_eof() and process.stderr.at_eof():
                break

            stdout = await process.stdout.readline()
            if stdout:
                await self.send(stdout.decode())
        await process.communicate()
        print(f'{command} exited with {process.returncode}')

